package coamonitor;

import javax.swing.*;
import com.borland.jbcl.layout.*;
import java.awt.*;
import coamonitor.*;

/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */



/*Componente dell'interfaccia grafica che riporta i risultati delle misurazioni
relative alle singole applicazioni */

public class ApplicationPanel extends JPanel {
  XYLayout xYLayout1 = new XYLayout();
  JTabbedPane jAppTabbedPane = new JTabbedPane();
  JPanel ServerPanel = new JPanel();
  XYLayout xYLayout2 = new XYLayout();
  JTextField jSrCallTextField = new JTextField();
  JTextField jSrSuccessTextField = new JTextField();
  JTextField jSrCallInsuccTextField = new JTextField();
  JTextField jSrCallTimeTextField = new JTextField();
  JLabel jSrCallNumberLabel = new JLabel();
  JLabel jSrCallSuccessLabel = new JLabel();
  JLabel jSrCallInsuccLabel = new JLabel();
  JLabel jSrCallTimeLabel = new JLabel();
  JLabel jLastCallLabel1 = new JLabel();
  JScrollPane jSrLastOpScrollPane = new JScrollPane();
  JTextArea jSrLastOpTextArea = new JTextArea();
  JTextField jBindSuccessTextField = new JTextField();
  JTextField jBindTimeTextField = new JTextField();
  JLabel jBindNumberLabel = new JLabel();
  JLabel jClLastOpCallLabel = new JLabel();
  JPanel ClientPanel = new JPanel();
  JLabel jClCallNumberLabel = new JLabel();
  JScrollPane jClLastOpScrollPane = new JScrollPane();
  JLabel jBindSuccLabel = new JLabel();
  JTextField jBindInsuccTextField = new JTextField();
  JTextField jClientCallTextField = new JTextField();
  JLabel jClCallSuccLabel = new JLabel();
  JTextField jClCallTimeTextField = new JTextField();
  JTextField jClCallInsuccTextField = new JTextField();
  JLabel jClCallTimeLabel = new JLabel();
  JLabel jClCallInsuccLabel = new JLabel();
  JTextField jBindTextField = new JTextField();
  JTextArea jClOpTextArea = new JTextArea();
  JLabel jBindInsuccLabel = new JLabel();
  JTextField jClSuccCallTextField = new JTextField();
  JLabel jBindTimeLabel = new JLabel();
  XYLayout xYLayout3 = new XYLayout();

  /*Data Manger associato al pannello*/
  InterceptorDataManager intDatMan = null;
  JScrollPane jMessagePane = new JScrollPane();
  JTextArea jMessageArea = new JTextArea();

  public ApplicationPanel() {
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }
  private void jbInit() throws Exception {
    this.setLayout(xYLayout1);
    xYLayout1.setWidth(563);
    xYLayout1.setHeight(501);
    ServerPanel.setLayout(xYLayout2);
    jSrCallNumberLabel.setText("Call");
    jSrCallSuccessLabel.setText("Success");
    jSrCallInsuccLabel.setText("Insucc.");
    jSrCallTimeLabel.setText("Time(ms)");
    jLastCallLabel1.setText("LastOperation");
    jBindNumberLabel.setText("Bind");
    jClLastOpCallLabel.setText("LastOperation");
    ClientPanel.setLayout(xYLayout3);
    jClCallNumberLabel.setText("Call");
    jBindSuccLabel.setText("Success");
    jClCallSuccLabel.setText("Success");
    jClCallTimeLabel.setText("Time(ms)");
    jClCallInsuccLabel.setText("Insucc.");
    jBindInsuccLabel.setText("Insucc.");
    jBindTimeLabel.setText("Time(ms)");
    jClientCallTextField.setText("0");
    jClSuccCallTextField.setText("0");
    jClCallInsuccTextField.setText("0");
    jClCallTimeTextField.setText("0");
    jBindTextField.setText("0");
    jBindSuccessTextField.setText("0");
    jBindInsuccTextField.setText("0");
    jBindTimeTextField.setText("0");
    jSrCallTextField.setText("0");
    jSrSuccessTextField.setText("0");
    jSrCallInsuccTextField.setText("0");
    jSrCallTimeTextField.setText("0");
    this.add(jAppTabbedPane, new XYConstraints(0, 0, 561, 366));
    jAppTabbedPane.add(ClientPanel, "Client");
    ClientPanel.add(jClientCallTextField, new XYConstraints(33, 53, 81, 29));
    ClientPanel.add(jClSuccCallTextField, new XYConstraints(168, 53, 81, 29));
    ClientPanel.add(jClCallInsuccTextField, new XYConstraints(302, 53, 81, 29));
    ClientPanel.add(jClCallTimeTextField, new XYConstraints(437, 53, 81, 29));
    ClientPanel.add(jClCallTimeLabel, new XYConstraints(437, 25, 81, 29));
    ClientPanel.add(jClCallInsuccLabel, new XYConstraints(302, 25, 81, 29));
    ClientPanel.add(jClCallSuccLabel, new XYConstraints(168, 25, 81, 29));
    ClientPanel.add(jBindSuccessTextField, new XYConstraints(168, 117, 81, 29));
    ClientPanel.add(jBindInsuccTextField, new XYConstraints(302, 117, 81, 29));
    ClientPanel.add(jBindTextField, new XYConstraints(33, 117, 81, 29));
    ClientPanel.add(jBindSuccLabel, new XYConstraints(168, 91, 81, 29));
    ClientPanel.add(jBindInsuccLabel, new XYConstraints(302, 91, 81, 29));
    ClientPanel.add(jBindTimeLabel, new XYConstraints(437, 91, 81, 29));
    ClientPanel.add(jBindTimeTextField, new XYConstraints(437, 117, 81, 29));
    ClientPanel.add(jBindNumberLabel, new XYConstraints(34, 91, 81, 29));
    ClientPanel.add(jClCallNumberLabel, new XYConstraints(33, 25, 81, 29));
    ClientPanel.add(jClLastOpScrollPane, new XYConstraints(33, 186, 496, 124));
    ClientPanel.add(jClLastOpCallLabel, new XYConstraints(32, 158, 81, 29));
    jClLastOpScrollPane.getViewport().add(jClOpTextArea, null);
    jAppTabbedPane.add(ServerPanel, "Server");
    ServerPanel.add(jSrLastOpScrollPane, new XYConstraints(33, 191, 496, 124));
    jSrLastOpScrollPane.getViewport().add(jSrLastOpTextArea, null);
    ServerPanel.add(jLastCallLabel1, new XYConstraints(33, 164, 81, 29));
    ServerPanel.add(jSrCallInsuccLabel, new XYConstraints(302, 56, 81, 29));
    ServerPanel.add(jSrCallNumberLabel, new XYConstraints(33, 56, 81, 29));
    ServerPanel.add(jSrCallTextField, new XYConstraints(33, 84, 81, 29));
    ServerPanel.add(jSrSuccessTextField, new XYConstraints(168, 84, 81, 29));
    ServerPanel.add(jSrCallSuccessLabel, new XYConstraints(168, 56, 81, 29));
    ServerPanel.add(jSrCallInsuccTextField, new XYConstraints(302, 84, 81, 29));
    ServerPanel.add(jSrCallTimeTextField, new XYConstraints(437, 84, 81, 29));
    ServerPanel.add(jSrCallTimeLabel, new XYConstraints(437, 56, 81, 29));
    this.add(jMessagePane, new XYConstraints(33, 394, 502, 86));
    jMessagePane.getViewport().add(jMessageArea, null);
  }

  //Settaggio e abilitazione di un DataManager
  public void setInterceptorDataManager(InterceptorDataManager idm){
    intDatMan = idm;
    intDatMan.setEnable(true);
  }//setInterceptorDataManager

  //Rimozione e disabilitazione del DataManager
  public void removeInterceptorDataManager(){
    intDatMan.setEnable(false);
    intDatMan = null;
  }//removeInterceptorDataManager

}//Application Panel