package coamonitor;

import java.awt.*;
import java.awt.event.*;
import javax.swing.*;
import com.borland.jbcl.layout.*;
import com.borland.cx.*;
import javax.swing.tree.*;
/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */


import coamonitor.Monitor.*;
import coamonitor.Interceptor.*;
import com.inprise.vbroker.CORBA.*;
import org.omg.PortableServer.*;
import java.util.*;
import com.inprise.vbroker.PortableServerExt.*;
import com.inprise.vbroker.ObjLocation.*;

public class COAMonitorFrame extends JFrame {

  JPanel contentPane;
  XYLayout xYLayout1 = new XYLayout();
  OrbConnect orbConnect1 = new OrbConnect();
  org.omg.CORBA.ORB orb;
  org.omg.PortableServer.POA listenerPOA;
  JTree interceptorTree;
  InterceptorFinder finder;
  InterceptorTreeManager treeManager;
  JScrollPane jTreeScrollPane = new JScrollPane();
  JPanel jPanel1 = new JPanel();
  ApplicationPanel appPanel = new ApplicationPanel();
  NodePanel nodePanel = new NodePanel();
  JButton RemoveListener = new JButton();
  JButton Register = new JButton();
  JButton newSearch = new JButton();

  /**Construct the frame*/
  public COAMonitorFrame() {
    enableEvents(AWTEvent.WINDOW_EVENT_MASK);
    try {
      jbInit();
    }
    catch(Exception e) {
      e.printStackTrace();
    }
  }//CoaMonitorFrame

  /**Component initialization*/
  private void jbInit() throws Exception  {
    //setIconImage(Toolkit.getDefaultToolkit().createImage(CAOMonitorFrame.class.getResource("[Your Icon]")));
    contentPane = (JPanel) this.getContentPane();
    contentPane.setLayout(xYLayout1);
    this.setSize(new Dimension(791, 629));
    this.setTitle("COA Monitor");
    nodePanel.setVisible(false);
    //Inizialize the ORB
    orbConnect1.setInitialize(true);
    orb = orbConnect1.getOrb();
    treeManager = new InterceptorTreeManager(orb,appPanel, nodePanel);
    interceptorTree = treeManager.getTree();
    interceptorTree.addMouseListener(new java.awt.event.MouseAdapter() {
      public void mouseClicked(MouseEvent e) {
        interceptorTree_mouseClicked(e);
      }
    });
    RemoveListener.setText("Remove ");
    RemoveListener.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        RemoveListener_actionPerformed(e);
      }
    });
    Register.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        Register_actionPerformed(e);
      }
    });
    Register.setText("Register");
    newSearch.addActionListener(new java.awt.event.ActionListener() {
      public void actionPerformed(ActionEvent e) {
        newSearch_actionPerformed(e);
      }
    });
    newSearch.setText("New Search");
    contentPane.add(jTreeScrollPane, new XYConstraints(28, 50, 148, 501));
    contentPane.add(appPanel, new XYConstraints(205, 50, 584, 504));
    contentPane.add(nodePanel, new XYConstraints(205, 50, 584, 504));
    contentPane.add(RemoveListener, new XYConstraints(210, 571, 140, 25));
    contentPane.add(Register, new XYConstraints(32, 571, 140, 25));
    contentPane.add(newSearch, new XYConstraints(388, 571, 140, 25));
    jTreeScrollPane.getViewport().add(interceptorTree, null);
  }//jbInit

  /**Overridden so we can exit when window is closed*/
  protected void processWindowEvent(WindowEvent e) {
    super.processWindowEvent(e);
    if (e.getID() == WindowEvent.WINDOW_CLOSING) {
      treeManager.removeAllListener();
      System.exit(0);
    }
  }//processWindowEvent

  /**Inizializza e attiva l'InterceptorListenerPOA */
  void initInterceptorListenerPOA(org.omg.CORBA.ORB orb){
    try{
    org.omg.PortableServer.POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
    String name = "InterceptorListener";
    //Cambia il valore della politica  BindSupportPolicy a BYINSTANCE
    BindSupportPolicy bindPolicy = BindSupportPolicyHelper.narrow((((com.inprise.vbroker.PortableServerExt.POA)rootPOA).the_policies())[7]);
    org.omg.CORBA.Any any = orb.create_any();
    BindSupportPolicyValueHelper.insert(any,bindPolicy.value().BY_INSTANCE);

    org.omg.CORBA.Policy[] InterceptorListenerPolicy = {
      rootPOA.create_lifespan_policy(LifespanPolicyValue.PERSISTENT),
      BindSupportPolicyHelper.narrow(orb.create_policy(bindPolicy.policy_type(),any))
    };
    listenerPOA = rootPOA.create_POA(name+"_poa",rootPOA.the_POAManager(),InterceptorListenerPolicy);
    rootPOA.the_POAManager().activate();
    }catch(Exception e){
      e.printStackTrace();
    }
  }//initInterceptorListenerPOA

  /**Risponde alle pressioni del Mouse in corrispoandenza dei nodi dell'albero */
  void interceptorTree_mouseClicked(MouseEvent e) {
    DefaultMutableTreeNode nodeSelected =(DefaultMutableTreeNode)interceptorTree.getLastSelectedPathComponent();
    if (nodeSelected != null){
        java.lang.Object thisObject = nodeSelected.getUserObject();
        if(thisObject instanceof TreeData){
        //Visualizza l'ApplicatioPanel se  nascosto
        if(nodePanel.isVisible()){
          appPanel.setVisible(true);
          nodePanel.setVisible(false);
        }
        //Abilita la visualizzazione dei dati corrispondenti al nodo
        TreeData td = (TreeData)thisObject;
        treeManager.enableInterceptorDataManager(td);
      }else{
        if(thisObject instanceof NodeData){
        //Visualizza il NodePanel se  nascosto
          if(appPanel.isVisible()){
            nodePanel.setVisible(true);
            appPanel.setVisible(false);
          }
          //Abilita la visualizzazione dei dati corrispondenti al nodo
          NodeData nodeData = (NodeData)thisObject;
          treeManager.enableNodeDataManager(nodeData);
        }
      }
    }
  }////InterceptorTree_mouseClicked

  /**Risponde alle pressioni del Mouse sul pulsante Remove */
  void RemoveListener_actionPerformed(ActionEvent e) {
    DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)interceptorTree.getLastSelectedPathComponent();
    if(selectedNode.getUserObject() instanceof TreeData){
      treeManager.removeListener(selectedNode);
    }
  }//RemoveListener_actionPerformed

  /**Risponde alle pressioni del Mouse sul pulsante register */
  void Register_actionPerformed(ActionEvent e) {
  DefaultMutableTreeNode selectedNode = (DefaultMutableTreeNode)interceptorTree.getLastSelectedPathComponent();
  java.lang.Object thisObject = selectedNode.getUserObject();
    if(thisObject instanceof TreeData){
      TreeData td = (TreeData)thisObject;
      try{
        //Invoca il metodo di registrazione
        treeManager.register(td);
      }catch(Exception exc){
        //Eccezzione sollevata se si tenta di registrarsi presso un'applicazione terminata
        treeManager.appShutDown(td.obDesc);
      }
    }
  }//////Register_actionPerformed

  /**Risponde alle pressioni del Mouse sul pulsante NewSearch */
  void newSearch_actionPerformed(ActionEvent e) {
    treeManager.finder.find();
  }/////////newSearch_actionPerformed

}//COAMonitorFrame