package coamonitor;

/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */
import coamonitor.Data.*;
import javax.swing.*;

public class ClientDataManager {

  int totCall = 0;
  int totBind = 0;
  int totCallSucc = 0;
  int totBindSucc = 0;
  int totCallInsucc = 0;
  int totBindInsucc = 0;
  int totCallTime = 0;
  int totBindTime = 0;

  boolean enable = true;

  //OutputPanel
  ApplicationPanel appPane = null;

  public ClientDataManager(ApplicationPanel ap) {
    appPane = ap;
  }

  public void displayClReqData(RequestData rd){
    totCall++;
    if(rd.result){
      totCallSucc++;
    }else{
      totCallInsucc++;
      appPane.jClCallInsuccTextField.setText((new Integer(totCallInsucc)).toString());
    }
    totCallTime = totCallTime+rd.time;

    if(enable){
      appPane.jClCallInsuccTextField.setText((new Integer(totCallInsucc)).toString());
      appPane.jClSuccCallTextField.setText((new Integer(totCallSucc)).toString());
      appPane.jClientCallTextField.setText((new Integer(totCall)).toString());
      appPane.jClCallTimeTextField.setText((new Integer(totCallTime)).toString());
      appPane.jClOpTextArea.append(reqDataToString(rd));
    }
  }//displayClReqData

  public void displayBindData(BindData bd){
    totBind++;
    if(bd.result){
      totBindSucc++;
    }else{
      totBindInsucc++;
    }
    totBindTime = totBindTime+bd.time;

    if(enable){
      appPane.jBindInsuccTextField.setText((new Integer(totBindInsucc)).toString());
      appPane.jBindSuccessTextField.setText((new Integer(totBindSucc)).toString());
      appPane.jBindTextField.setText((new Integer(totBind)).toString());
      appPane.jBindTimeTextField.setText((new Integer(totBindTime)).toString());
      appPane.jClOpTextArea.append(bindDataToString(bd));
    }
  }//displayBindData

  public void displayMessage(String in){
    if(enable){
      appPane.jMessageArea.append(in+"\n");
    }
  }//displayMessage

  public String reqDataToString(RequestData rd){
    String output = "";
    String result = "";

    if(rd.result){  result = "Success"; }
    else{ result = "Fail";  }

    output = "Object Name: "+rd.ObjectName+"\nOperation Name: "+rd.OperationName+"\nResult: "+result
    +"\nOperationTime: "+rd.time+"\n\n";
    return output;
  }//requestDataToString

  public String bindDataToString(BindData bd){
    String output = "";
    String result = "";
    if(bd.result){  result = "Success"; }
    else{ result = "Fail";  }
    output = "Object Name: "+bd.ObjectName+"\nInterface Name: "+bd.interfaceName+"\nResult: "+result
      +"\nBind Time: "+bd.time+"\n\n";
    return output;
  }//bindDataToString

  public void setEnabe(boolean en){
    enable = en;
  }//setEnabe
}