package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */


import com.inprise.vbroker.IOP.IORValue;
import org.omg.CORBA.Object;
import com.inprise.vbroker.interceptor.*;
import org.omg.CORBA.Environment;
import coamonitor.Monitor.*;
import coamonitor.Data.*;


/*Interceptor che rileva le chiamate ai metodi di Bind */
public class ISBindInterceptor implements BindInterceptor, ListenerProvider {
  String _id = "";
  ClientRequestInterceptor clReqInt;
  InterceptorListener intList = null;
  BindData bindData;

  //Costruttori
  public ISBindInterceptor(String id) {
    _id = id;
  }

  //Acquisizione e rimozione del Listener
  public void getListener(InterceptorListener il) {
    if(intList == null){
      intList = il;
    }
  }//getListener

  //rimozione del Listner
  public void removeListener() {
    intList = null;
  }//removeListener

  //Implementazione del metodo dell'interfaccia LIstener Provider
  public InterceptorListener provideListener(){
    return intList;
  }//provideListener

  //Implementazione dei metodi dell'interfaccia BindInterceptor
  public IORValue bind(IORValue ior, Object obj, boolean parm3, Closure closure) {
    //Esclude dall'intercettazione i bind agli oggetti di questa applicazione
    if(!ior.type_id.equals("IDL:Monitor/InterceptorListener:1.0")
        &(!ior.type_id.equals("IDL:Monitor/MonitorBinder:1.0"))
        ){
      //inizializza il Timer
      InterceptorTimer intTimer = new InterceptorTimer();
      intTimer.tStart();
      closure.object = new ClosureObject(ior.toString(), intTimer);
      //assegna i valori ai dati da inviare al Monitor
      bindData = new BindData("","",false,0,"");
      bindData.interfaceName = ior.type_id;
    }
    return ior;
  }//bind


  public IORValue bind_failed(IORValue ior, Object obj, Closure closure) {
    try{
      String type = ior.type_id;
      ClosureObject co = (ClosureObject)closure.object;
      //Esclude dall'intercettazione i bind agli oggetti di questa applicazione
      if(!type.equals("IDL:Monitor/InterceptorListener:1.0")
        &(!type.equals("IDL:Monitor/MonitorBinder:1.0"))){
        InterceptorTimer intTimer = co.getTimer();
        intTimer.tStop();
        //Raccolta dei dati dell'invocazione
        bindData.ObjectName = obj.toString();
        bindData.result = false;
        bindData.time = intTimer.getTime();
        //Invia i risultati al Listener solo se esiste un Listener registrato
        if(intList != null){
          intList.bindReport(bindData);
        }//if
      }//if
    }catch(Exception e){
      e.printStackTrace();
    }//catch
    return ior;
  }//bind_failed

  public void bind_succeeded(IORValue ior, Object obj, int parm3, InterceptorManagerControl imc, Closure closure) {

    try{
      ClosureObject co = (ClosureObject)closure.object;
      //t.interrupt();
      String type = ior.type_id;
      String thisIOR = ior.toString();
      //Esclude dall'intercettazione i bind agli oggetti di questa applicazione
      if(!type.equals("IDL:Monitor/InterceptorListener:1.0")
          &(!type.equals("IDL:Monitor/MonitorBinder:1.0"))){
         //Ferma il timer
        InterceptorTimer intTimer = co.getTimer();
        intTimer.tStop();
        //assegna i valori ai dati da inviare al Monitor
        bindData.ObjectName = obj.toString();
        bindData.result = true;
        bindData.time = intTimer.getTime();
        intTimer.reset();
        //Crea un nuovo ISClientInterceptor
        clReqInt = new ISClientInterceptor(ior.toString(),this);
        ClientRequestInterceptorManager cl_manager = (ClientRequestInterceptorManager)imc.get_manager("ClientRequest");
        cl_manager.add(clReqInt);
      }//if
      //Invia i risultati dell'intercettazione se esiste un Listener registrato
      if(intList != null){
          intList.bindReport(bindData);
      }//if
    }catch(Exception e){
        e.printStackTrace();
    }//catch
  }//bind_succeeded

  public void exception_occurred(IORValue ior, Object obj, Environment env, Closure closure) {
    try{
      String type = ior.type_id;
      ClosureObject co = (ClosureObject)closure.object;
      //Esclude dall'intercettazione i bind agli oggetti di questa applicazione
      if(!type.equals("IDL:Monitor/InterceptorListener:1.0")
          &(!type.equals("IDL:Monitor/MonitorBinder:1.0"))){
        //Ferma il timer
        InterceptorTimer intTimer = co.getTimer();
        intTimer.tStop();
        //assegna i valori ai dati da inviare al Monitor
        bindData.ObjectName = obj.toString();
        bindData.result = false;
        bindData.time = intTimer.getTime();
        intTimer.reset();
        bindData.exc = env.exception().toString();
        //Invia i dati al Monitor
        if(intList != null){
          intList.bindReport(bindData);
        }
      }
    }catch(Exception e){
      e.printStackTrace();
    }
  }//exception_occurred


}