package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import com.inprise.vbroker.interceptor.ClientRequestInterceptor;
import org.omg.CORBA.Object;
import org.omg.CORBA.Environment;
import com.inprise.vbroker.interceptor.*;
import com.inprise.vbroker.IOP.ServiceContext;
import com.inprise.vbroker.CORBA.portable.InputStream;
import com.inprise.vbroker.CORBA.portable.OutputStream;
import com.inprise.vbroker.IOP.ServiceContextListHolder;
import coamonitor.Monitor.*;
import coamonitor.Data.*;
import java.util.Vector;


/*Intercetta le invocazioni da parte di clienti agli oggetti remoti */
public class ISClientInterceptor implements ClientRequestInterceptor{

  String _id = "";
  private InterceptorListener intList = null;
  boolean listReg = false;
  private ListenerProvider lp;
  RequestData reqData;

  public ISClientInterceptor(String id, ListenerProvider l) {
    _id = id;
    lp = l;
  }

  /**Implementazione dei metodi dell'interfaccia InterceptorClientRequest */
  public void exception_occurred(Object obj, Environment env, Closure closure) {
     try{
      int thisID = ((ExtendedClosure)closure).reqInfo.request_id;
      String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior_value().toString();
      ClosureObject co = (ClosureObject)closure.object;
      if(ior.equals(_id)){
        //Ferma il Timer
          InterceptorTimer intTimer = co.getTimer();
          intTimer.tStop();
          //Assegna i valori ai dati da inviare al Monitor
          reqData.ObjectName = obj.toString();
          reqData.time = intTimer.getTime();
          intTimer.reset();
          reqData.result = false;
          reqData.exc = env.exception().toString();
          //Invia i dati al Monitor
          if(listReg) {
            intList.clientInvocationReport(reqData);
          }
      }
    }catch(Exception e){
      e.printStackTrace();
    }
  }//exception_occurred

  public void postinvoke(Object obj, ServiceContext[] serv, InputStream parm3, Environment parm4, Closure closure) {

    try{
      int thisID = ((ExtendedClosure)closure).reqInfo.request_id;
      String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior_value().toString();
      ClosureObject co = (ClosureObject)closure.object;
      if(ior.equals(_id)){
          //Ferma il Timer
          InterceptorTimer intTimer = co.getTimer();
          intTimer.tStop();
          //Assegna i valori ai dati da inviare al Monitor
          reqData.ObjectName = obj.toString();
          reqData.time = intTimer.getTime();
          intTimer.reset();
          reqData.result = true;
          //Invia i dati al Monitor
          if(listReg) {
            intList.clientInvocationReport(reqData);
          }
      }
    }catch(Exception e){
      e.printStackTrace();
    }catch(java.lang.Throwable th){
      th.printStackTrace();
    }
  }//postinvoke

  public void preinvoke_postmarshal(Object obj, OutputStream parm2, Closure parm3) {  }

  public void preinvoke_premarshal(Object obj, String operation, ServiceContextListHolder parm3, Closure closure) {
    String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior_value().toString();
    if(ior.equals(_id)){
      //Inizializza il timer
      InterceptorTimer intTimer = new InterceptorTimer();
      intTimer.tStart();
      closure.object = new ClosureObject(ior, intTimer);
      //assegna i valori ai dati da inviare al Monitor
      reqData = new RequestData("","",false,0,"");
      reqData.ObjectName = obj.toString();
      reqData.OperationName = operation;
      //tenta l'acquisizione del Listener
      InterceptorListener il = lp.provideListener();
      if(!listReg){
        if(il != null){
          intList = il;
          listReg = true;
        }
      }else{
        if(il == null){
          intList = null;
          listReg = false;
        }
      }
    }
  }//preinvoke_premarshal
}