package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import com.inprise.vbroker.interceptor.ServerRequestInterceptor;
import org.omg.CORBA.*;
import com.inprise.vbroker.interceptor.*;
import com.inprise.vbroker.CORBA.portable.OutputStream;
import com.inprise.vbroker.IOP.ServiceContextListHolder;
import com.inprise.vbroker.IOP.ServiceContext;
import com.inprise.vbroker.CORBA.portable.InputStream;
import coamonitor.Data.*;
import coamonitor.Monitor.*;
import com.inprise.vbroker.IIOP.ProfileBodyValue;


/**Intercetta le invocazioni ai metodi di un'oggetto servitore */
public class ISServerInterceptor implements ServerRequestInterceptor{

  String _id = "";
  com.inprise.vbroker.CORBA.Object object;
  InterceptorListener intList;
  boolean listReg = false;
  RequestData reqData;
  ListenerProvider lp;
  InterceptorManagerControl intManContr ;

  //Costruttori
  public ISServerInterceptor(String id, ListenerProvider l,InterceptorManagerControl imc) {
    _id = id;
    lp=l;
    intManContr = imc;
  }//ISServerInterceptor

  //Metodi dell'interfaccia ServerRequestInterceptor
  public void exception_occurred(org.omg.CORBA.Object obj, Environment env, Closure closure) {
    try{
      String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior().toString();
      int ID = ((ExtendedClosure)closure).reqInfo.request_id;
      ClosureObject co =(ClosureObject)closure.object;
        if(co.getIor().equals(ior)){
          InterceptorTimer intTimer = co.getTimer();
          intTimer.tStop();
          reqData.time = intTimer.getTime();
          intTimer.reset();
          reqData.result = false;
          reqData.exc = env.exception().toString();
          //Invia i risultati dell'invocazione se esiste un Listener rregistrato
          if(listReg) {
            intList.serverInvocationReport(reqData);
          }
        }
    }catch(Exception e){
      e.printStackTrace();
    }
  }//Exception_occurred

  public void postinvoke_postmarshal(org.omg.CORBA.Object obj, OutputStream out, Closure closure) {

    try{
      String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior().toString();
      int ID = ((ExtendedClosure)closure).reqInfo.request_id;
      ClosureObject co =(ClosureObject)closure.object;
      if(co.getIor().equals(ior)){
          InterceptorTimer intTimer = co.getTimer();
          intTimer.tStop();
          reqData.time = intTimer.getTime();;
          intTimer.reset();
          reqData.result = true;
          if(listReg) {
            intList.serverInvocationReport(reqData);
          }
      }
    }catch(Exception e) {
      e.printStackTrace();
    }
  }//postinvoke_postmarshal


  public void postinvoke_premarshal(org.omg.CORBA.Object obj, ServiceContextListHolder parm2, Environment parm3, Closure parm4) {
  }//Postinvoke_premarshal

  public void preinvoke(org.omg.CORBA.Object obj, String operation, ServiceContext[] parm3, InputStream in, Closure closure) throws com.inprise.vbroker.interceptor.ForwardRequestException {

    String ior = ((com.inprise.vbroker.CORBA.Object)obj)._ior().toString();
    //Inizializzazione del cronometro
    InterceptorTimer intTimer = new InterceptorTimer();
    intTimer.tStart();
    closure.object = new ClosureObject(ior, intTimer);
    //Preparazione dei dati da inviare al client
    reqData = null;
    reqData = new RequestData("","",false,0,"");
    reqData.ObjectName = obj.toString();
    reqData.OperationName = operation;
    InterceptorListener il = lp.provideListener();
    //Registrazione del lisener
    if(!listReg){
      if(il != null) {
        intList = il;
        listReg = true;
      }
    }else{
      if(il == null){
        intList = null;
        listReg = false;
      }
    }
  }//preinvoke
}//ISSerevreInterceptor

