package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import coamonitor.Data.*;
import javax.swing.*;

/*Gestisce i dati provenienti dagli Interceptor e li rende adatti ad essere
presentati sull'applicationPanel */
public class InterceptorDataManager {

  //Dati registrati, lato client
  int totClCall = 0;
  int totBind = 0;
  int totClCallSucc = 0;
  int totBindSucc = 0;
  int totClCallInsucc = 0;
  int totBindInsucc = 0;
  int totClCallTime = 0;
  int totBindTime = 0;
  String clLastOp = "";
  int clReqCount = 0;

  //Dati registrati, lato server
  int totSrCall = 0;
  int totSrCallSucc = 0;
  int totSrCallInsucc = 0;
  int totSrCallTime = 0;
  String srLastOp = "";
  int srReqCount = 0;
  boolean enable = true;
  ApplicationPanel appPane;
  NodeDataManager nodeDataManager;

  //Costruttori
  public InterceptorDataManager(ApplicationPanel ap) {
    appPane = ap;
    appPane.setInterceptorDataManager(this);
  }//InterceptorDataManager

  /*Permette l'aggiornamento dei dati locali e la visualizzazione sull'ApplicationPanel dei dati
  corrispondenti ad una chiamata cliente appena terminata */
  public void displayClReqData(RequestData rd){
    totClCall++;
    if(rd.result){
      totClCallSucc++;
    }else{
      totClCallInsucc++;
      appPane.jClCallInsuccTextField.setText((new Integer(totClCallInsucc)).toString());
    }
    totClCallTime = totClCallTime+rd.time;
    nodeDataManager.displayClData(rd.time);
    String st = new String(clientReqDataToString(rd));
    clLastOp = clLastOp.concat(st);
    if(enable){
      appPane.jClCallInsuccTextField.setText((new Integer(totClCallInsucc)).toString());
      appPane.jClSuccCallTextField.setText((new Integer(totClCallSucc)).toString());
      appPane.jClientCallTextField.setText((new Integer(totClCall)).toString());
      appPane.jClCallTimeTextField.setText((new Integer(totClCallTime)).toString());
      appPane.jClOpTextArea.append(st);
    }
  }//displayClReqData

  /*Permette la visualizzazione sull'ApplicationPanel dei dati
  corrispondenti ad una chiamata di Bind appena terminata */
  public void displayBindData(BindData bd){
    totBind++;
    if(bd.result){
      totBindSucc++;
    }else{
      totBindInsucc++;
    }
    totBindTime = totBindTime+bd.time;
    String st = new String(bindDataToString(bd));
    clLastOp = clLastOp.concat(st);
    if(enable){
      appPane.jBindInsuccTextField.setText((new Integer(totBindInsucc)).toString());
      appPane.jBindSuccessTextField.setText((new Integer(totBindSucc)).toString());
      appPane.jBindTextField.setText((new Integer(totBind)).toString());
      appPane.jBindTimeTextField.setText((new Integer(totBindTime)).toString());
      appPane.jClOpTextArea.append(st);
    }
  }//displayBindData

  /*Permette la visualizzazione sull'ApplicationPanel dei messaggi
  testuali provenienti dagli Interceptor */
  public void displayMessage(String in){
    if(enable){
      appPane.jMessageArea.append(in+"\n");
    }
  }//displayClientMessage

  //*Trasforma la struttura bindData in una Stringa stampabile a video */
  String bindDataToString(BindData bd){
    String output = "";
    String result = "";
    if(bd.result){  result = "Success"; }
    else{ result = "Fail";  }
    output = "**Bind Operation**\n"+"Object Name: "+bd.ObjectName+"\nInterface Name: "+bd.interfaceName+"\nResult: "+result
      +"\nBind Time: "+bd.time+"\n\n";
    return output;
  }//bindDataToString

  /*Permette l'aggiornamento dei dati locali e la visualizzazione sull'ApplicationPanel
  dei dati corrispondenti ad una chiamata server appena terminata */
  public void displaySrReqData(RequestData rd){
    totSrCall++;
    if(rd.result){
      totSrCallSucc++;
    }else{
      totSrCallInsucc++;
    }
    totSrCallTime = totSrCallTime+rd.time;
    nodeDataManager.displaySrData(rd.time);
    String st = new String(serverReqDataToString(rd));
    srLastOp = srLastOp.concat(st);
    if(enable){
      //ServerData
      appPane.jSrCallInsuccTextField.setText((new Integer(totSrCallInsucc)).toString());
      appPane.jSrSuccessTextField.setText((new Integer(totSrCallSucc)).toString());
      appPane.jSrCallTextField.setText((new Integer(totSrCall)).toString());
      appPane.jSrCallTimeTextField.setText((new Integer(totSrCallTime)).toString());
      appPane.jSrLastOpTextArea.append(st);
    }
  }//displayClReqData

  /*Trasforma la struttura ReqData ottenuta da un'invocazione cliente
   in una Stringa stampabile a video */
   String clientReqDataToString(RequestData rd){
    String output = "";
    String result = "";
    if(rd.result){  result = "Success"; }
    else{ result = "Fail";  }
    output = "**Client Operation**\n"+"Object Name: "+rd.ObjectName+"\nOperation Name: "+rd.OperationName+"\nResult: "+result
    +"\nOperationTime: "+rd.time+"\n\n";
    return output;
  }//clientReqDataToString

  /*Trasforma la struttura ReqData ottenuta da un'invocazione ricevuta
  da un server in una Stringa stampabile a video */
   String serverReqDataToString(RequestData rd){
    String output = "";
    String result = "";
    if(rd.result){  result = "Success"; }
    else{ result = "Fail";  }
    output = "**Server Operation**\n"+"Object Name: "+rd.ObjectName+"\nOperation Name: "+rd.OperationName+"\nResult: "+result
    +"\nOperationTime: "+rd.time+"\n\n";
    return output;
  }//serverReqDataToString

  /*permette la visualizzazione sull'ApplicationPanel dei dati attuali */
  void dysplayCurrentData(){
    //ClientData
    appPane.jBindInsuccTextField.setText((new Integer(totBindInsucc)).toString());
    appPane.jBindSuccessTextField.setText((new Integer(totBindSucc)).toString());
    appPane.jBindTextField.setText((new Integer(totBind)).toString());
    appPane.jBindTimeTextField.setText((new Integer(totBindTime)).toString());
    appPane.jClCallInsuccTextField.setText((new Integer(totClCallInsucc)).toString());
    appPane.jClSuccCallTextField.setText((new Integer(totClCallSucc)).toString());
    appPane.jClientCallTextField.setText((new Integer(totClCall)).toString());
    appPane.jClCallTimeTextField.setText((new Integer(totClCallTime)).toString());
    appPane.jClOpTextArea.setText(clLastOp);

    //ServerData
    appPane.jSrCallInsuccTextField.setText((new Integer(totSrCallInsucc)).toString());
    appPane.jSrSuccessTextField.setText((new Integer(totSrCallSucc)).toString());
    appPane.jSrCallTextField.setText((new Integer(totSrCall)).toString());
    appPane.jSrCallTimeTextField.setText((new Integer(totSrCallTime)).toString());
    appPane.jSrLastOpTextArea.setText(srLastOp);
  }//dysplayCurrentData

  /*Acquisisce un riferimento ad un NodeDataManger */
  public void setNodeDataManager(NodeDataManager ndm){
    nodeDataManager = ndm;
  }//getNodeDataManager

  /*Abilita questo dataManager all'immissione dei dati sull'AppPanel */
  public void setEnable(boolean en){
    enable = en;
    if(enable){
      this.dysplayCurrentData();
    }
  }//setEnabe
}