package coamonitor;

/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */
import coamonitor.Interceptor.*;
import org.omg.PortableServer.*;
import com.inprise.vbroker.ObjLocation.*;

/*Esesgue le ricerche presso lo SmartAgent e svolge il ruolo di
  Trigger */
public class InterceptorFinder extends TriggerHandlerPOA {

  String repID = "IDL:Interceptor/MonitorBinder:1.0";
  //String instanceName = "MonitorBinder";
  TriggerDesc td = new TriggerDesc(repID, "", "");
  com.inprise.vbroker.ObjLocation.Agent agent;
  FinderListener listener;
  org.omg.CORBA.ORB _orb;

  //Costruttore
  public InterceptorFinder(org.omg.CORBA.ORB orb,FinderListener f) {
    try{
    listener = f;
    _orb = orb;
    //Inizializzazione dell'Agent
    POA rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
    rootPOA.the_POAManager().activate();
    rootPOA.activate_object(this);
    agent = AgentHelper.narrow(orb.resolve_initial_references("LocationService"));
    //Registrazione del Trigger presso l'agente
    agent.reg_trigger(td,this._this());
    }catch(Exception e){
      e.printStackTrace();
    }
  }

  //Metodo di ricerca dei MonitorBinder
  public void find(){
    int i = 0;
    Desc[] allDesc_rem = null;
    try{
      allDesc_rem = agent.all_instances_descs(repID);
      for(i=0; i<allDesc_rem.length; i++){
        //Controlla l'effettiva esistenza dell'oggetto corrispondente alla
        //descrizione trovata prima di avvertire il Listener
        if(!MonitorBinderHelper.narrow(allDesc_rem[i].ref)._non_existent()){
          listener.interceptorFound(allDesc_rem[i]);
        }
      }
    }catch(Exception e){
      listener.deleteInterceptor(allDesc_rem[i]);
      this.find();
    }
  }//find

  //Implementazione dell'interfaccia TriggerHandlerInterface
  public void impl_is_ready(com.inprise.vbroker.ObjLocation.Desc desc){
  }//impl_is_ready

  public void impl_is_down(com.inprise.vbroker.ObjLocation.Desc desc){
    listener.deleteInterceptor(desc);
  }//impl_is_down
}//IntercptorFinder