
/**
 * Copyright (c) 2001
 * Template File
 *   InterfaceServerObject.java.template
 * IDL Object
 *   coamonitor.Monitor.InterceptorListener
 * Generation Date
 *   sabato 16 giugno 2001 22.44.55 GMT+02:00
 * IDL Source File
 *   C:/INGEGNERIA/Reti/Corba/COAMonitor/src/coamonitor/COAMonitor.idl
 * Abstract
 *   Provides default implementation for the server side of a CORBA factory interface.
 * @version 1.0
 */

package coamonitor;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import coamonitor.Monitor.*;

/*Oggetto servitore che implementa l'interfaccia IDL Interceptor Listener.
  Funge da Target per il callback da parte degli Interceptor*/

public class InterceptorListenerServerImpl extends coamonitor.Monitor.InterceptorListenerPOA {

  String _name = "InterceptorListener";
  InterceptorListener interceptorListener;
  InterceptorTreeManager intTreeMan;
  InterceptorDataManager intDatMan;

  //Costruttori
  public InterceptorListenerServerImpl(java.lang.String name, POA poa) {
    this._name = name;
    init(poa);
  }

  public InterceptorListenerServerImpl(POA poa) {
    init(poa);
  }

  //Metodo d'inizializzazione
  private void init(POA poa){
    try{
      poa.activate_object_with_id(_name.getBytes(),this);
      interceptorListener = InterceptorListenerHelper.narrow(poa.servant_to_reference(this));
    }catch(Exception e){
      e.printStackTrace();
    }
  }//init

  //acquisizione dell'interceptorDatManger a cui inviare i dati ottenuti
  public void getInterceptorDataManager(InterceptorDataManager idm){
    intDatMan = idm;
  }//getServerDataManager

  //restituisce la reference all'oggetto astrato CORBA
  public InterceptorListener getReference(){
    return interceptorListener;
  }//ServerInterceptorListener

  //Method for IDL interface
  public void clientInvocationReport(coamonitor.Data.RequestData rd)  {
    intDatMan.displayClReqData(rd);
  }//ClientInvocationReport

  //Metodo invocato dall'Interceptor in seguito alla rilevazione di una invocazione
  //sul lato server
  public void serverInvocationReport(coamonitor.Data.RequestData rd)  {
    intDatMan.displaySrReqData(rd);
  }//ServerInvocationReport

  //Metodo invocato dall'Interceptor in seguito ad un'invocazione di Bind da parte
  //di un cliente
  public void bindReport(coamonitor.Data.BindData bd)  {
    intDatMan.displayBindData(bd);
  }//BindReport

  //Metodo invocato dall'Interceptor per l'invio di un messaggio testuale al Monitor
  public void sendMessage(String str)  {
    intDatMan.displayMessage(str);
  }//sendClientMessage
}//InterceptorLIstenerServerImpl
