package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

import org.omg.CORBA.*;
import com.inprise.vbroker.interceptor.*;
import org.omg.PortableServer.*;
import com.inprise.vbroker.PortableServerExt.*;
import com.inprise.vbroker.ObjLocation.Desc;
import com.inprise.vbroker.ObjLocation.*;
import coamonitor.Monitor.*;


/**Carica dinamicamente il servizio d'intercettazione all'inizializzazione dell'ORB */
public class InterceptorServiceLoader implements ServiceLoader, ListenerRegister{

  org.omg.PortableServer.POA rootPOA;
  MonitorBinderServerImpl monitorbinder;
  POALifeCycleInterceptor poaInt;
  BindInterceptor bindInt;
  InterceptorListener intList;

  String appName = "";
  public InterceptorServiceLoader() {
  }

  //Metodo dell'interfaccia Service Loader
  public void init(org.omg.CORBA.ORB orb) {
    //Inizialization
    appName = this.appNametoString(System.getProperties().getProperty("user.dir"));
    this.initInterceptors(orb);
    this.initMonitorBinder(orb);
  }//init

  /*Metodo che inizializza il MonitorBinder */
   void initMonitorBinder(org.omg.CORBA.ORB orb) {
    try{
      //Obtain rootPOA
      rootPOA = POAHelper.narrow(orb.resolve_initial_references("RootPOA"));
      //Impostando questa Policy al valore BY_INSTANCE il Location Service
      // registra ogni oggetto creato e non solo il POA presso cui  registrato.
      BindSupportPolicy bindPolicy = BindSupportPolicyHelper.narrow((((com.inprise.vbroker.PortableServerExt.POA)rootPOA).the_policies())[7]);
      Any any = orb.create_any();
      BindSupportPolicyValueHelper.insert(any,bindPolicy.value().BY_INSTANCE);

      org.omg.CORBA.Policy[] MonitorBinderPolicies = {
      rootPOA.create_lifespan_policy(LifespanPolicyValue.PERSISTENT),
      BindSupportPolicyHelper.narrow(orb.create_policy(bindPolicy.policy_type(),any))
      };
      //Creazione del POA per i MoniotrBinder col nome MonitorBinder_poa
      String name = "MonitorBinder";
      org.omg.PortableServer.POA poaMonitorBinder = rootPOA.create_POA(name+"_poa",
                                        rootPOA.the_POAManager(),
                                        MonitorBinderPolicies);
      monitorbinder = new MonitorBinderServerImpl(appName, this);
      poaMonitorBinder.activate_object_with_id(appName.getBytes(),monitorbinder);
      //attivazione del POA
      rootPOA.the_POAManager().activate();
    }catch(Exception e) {
      e.printStackTrace();
    }
  }//initMonitorBinder

  //Metodo d'inizializzazione degli Interceptor
  void initInterceptors(org.omg.CORBA.ORB orb) {
    try {
      //Intrecpetor controller
      InterceptorManagerControl control = InterceptorManagerControlHelper.narrow(orb.resolve_initial_references("VisiBrokerInterceptorControl"));
      //Installazzione del  POALifeCycleInterceptor
      POALifeCycleInterceptorManager poa_manager =(POALifeCycleInterceptorManager) control.get_manager("POALifeCycle");
      poaInt = new ISPOAInterceptor("ISPOAInterceptor");
      poa_manager.add(poaInt);
      //Installazione del BindInterceptor
      bindInt = new ISBindInterceptor("ISBindInterceptor");
      BindInterceptorManager bind_manager =(BindInterceptorManager) control.get_manager("Bind");
      bind_manager.add(bindInt);
    }catch(Exception e) {
      e.printStackTrace();
      throw new org.omg.CORBA.INITIALIZE(e.toString());
    }
  }//initIntercepotrs

  //Implementazione dei metodi dell'interfaccia Listener Register
  public void listenerReg (InterceptorListener il) {
    if(intList == null){
      intList = il;
      ((ISPOAInterceptor)poaInt).getListener(intList);
      ((ISBindInterceptor)bindInt).getListener(intList);
    }
  }//ClientListenerReg

  public void listenerUnreg () {
    intList = null;
    ((ISBindInterceptor)bindInt).removeListener();
    ((ISPOAInterceptor)poaInt).removeListener();
  }//ClientListenerReg

  //restituisce il nome dell'applicazione che ha attivato il servizio
  String appNametoString(String in){
    int index = 0;
    index = in.lastIndexOf("\\");
    return in.substring(++index);
  }//appNametoString

  //Metodi dell'interfaccia Service Loader non implementati
  public void init_complete(org.omg.CORBA.ORB orb) {   }
  public void shutdown(org.omg.CORBA.ORB orb) {   }
}//InterceptorServiceLoader