
/**
 * Copyright (c) 2001
 * Template File
 *   InterfaceServerObject.java.template
 * IDL Object
 *   coamonitor.Interceptor.MonitorBinder
 * Generation Date
 *   sabato 16 giugno 2001 20.58.14 GMT+02:00
 * IDL Source File
 *   C:/INGEGNERIA/Reti/Corba/COAMonitor/src/coamonitor/COAMonitor.idl
 * Abstract
 *   Provides default implementation for the server side of a CORBA factory interface.
 * @version 1.0
 */

package coamonitor;

import org.omg.CORBA.*;
import org.omg.PortableServer.*;
import coamonitor.Monitor.*;

/*Implementa i metodi dell'oggetto astratto CORBA MonitorBinder */
public class MonitorBinderServerImpl extends coamonitor.Interceptor.MonitorBinderPOA {

  String _name = "MonitorBinder";
  ListenerRegister register = null;
  InterceptorListener il = null;

  //Costruttori
  public MonitorBinderServerImpl(java.lang.String name, ListenerRegister lr) {
    this._name = name;
    this.init(lr);
  }

  public MonitorBinderServerImpl(ListenerRegister lr) {
    this.init(lr);
  }

  //Metodo d'inizializzazione
  public void init(ListenerRegister lr) {
    if(register == null) {
      register = lr;
    }
  }//init

  //Metodo invocato dal Monitor che vuole registrarsi presso quest'Interceptor
  public void addListener(org.omg.CORBA.Object listener)  {
    if(il == null) {
      il = InterceptorListenerHelper.narrow(listener);
      il.sendMessage("Interceptor-"+this._name+": Listener registered\n");
      register.listenerReg(il);
    }else{
      il.sendMessage("Interceptor-"+this._name+": Listener Already registered\n");
    }
  }//addListener

  //Metodo chiamato dal Monitor che vuole rimuovere il proprio LIstener
  public void removeListener()  {
    if(il != null){
      il.sendMessage("Interecptor-"+this._name+": Listener Removed\n");
      il = null;
      register.listenerUnreg();
    }else{
      il.sendMessage("Interceptor-"+this._name+": No Listener Registered");
    }
  }//removeListener
}
