package coamonitor;

/**
 * Title:
 * Description:
 * Copyright:    Copyright (c) 2001
 * Company:
 * @author
 * @version 1.0
 */

/*Gestisce i dati provenienti dagli InterceptorDataManger e li rende adatti ad essere
presentati sul NodePanel */
public class NodeDataManager {
  String _ip="";
  NodePanel nodePanel;
  boolean enable = false;
  RootDataManager rootDataManager;

  //Dati memorizzati
  float clReqRate = 0;
  float clTimeRate = 0;
  float srReqRate = 0;
  float srTimeRate = 0;

  //Costruttori
  public NodeDataManager(String ip, NodePanel np, RootDataManager rdm) {
    _ip = ip;
    nodePanel = np;
    rootDataManager = rdm;
    nodePanel.setNodeDataManager(this);
  }//NodeDataManager

  /**Aggiorna i dati dei client e in caso di abilitazione li invia all'interfaccia grafica*/
  public void displayClData(int tr){
    clReqRate = clReqRate + 1;
    clTimeRate = clTimeRate + tr;
    rootDataManager.updateClTotData(tr);
    if(enable){
      nodePanel.jClReqRateTextField.setText((new Float((clReqRate/rootDataManager.getTotClReq()*100)).toString()));
      nodePanel.jClReqTimeTextField.setText((new Float((clTimeRate/rootDataManager.getTotClTime()*100)).toString()));
    }

  }//displayClData

  //Aggiorna i dati dei server e in caso di abilitazione li invia all'interfaccia grafica
  public void displaySrData(int tr){
    srReqRate = srReqRate + 1;
    srTimeRate = srTimeRate + tr;
    rootDataManager.updateSrTotData(tr);
    if(enable){
      nodePanel.jSrReqRateTextField.setText((new Float((srReqRate/rootDataManager.getTotSrReq())*100).toString()));
      nodePanel.jSrReqTimeTextField.setText((new Float((srTimeRate/rootDataManager.getTotSrTime())*100).toString()));
    }
  }//displaySrData

  //Visualizza i dati salvati sull'interfaccia grafica utente
  void dysplayCurrentData(){
    if(((rootDataManager.getTotClReq())*(rootDataManager.getTotClTime())*(rootDataManager.getTotSrReq())*(rootDataManager.getTotSrTime())) != 0){
      nodePanel.jClReqRateTextField.setText((new Float((clReqRate/rootDataManager.getTotClReq())*100).toString()));
      nodePanel.jClReqTimeTextField.setText((new Float((clTimeRate/rootDataManager.getTotClTime())*100).toString()));
      nodePanel.jSrReqRateTextField.setText((new Float((srReqRate/rootDataManager.getTotSrReq())*100).toString()));
      nodePanel.jSrReqTimeTextField.setText((new Float((srTimeRate/rootDataManager.getTotSrTime())*100).toString()));
    }
  }//dysplayCurrentData

  //Abilita questo NodeDataManager a visualizzare i propri dati sull'interfaccia grafica utente
  public void setEnable(boolean en){
    enable = en;
    if(enable){
      this.dysplayCurrentData();
      nodePanel.jTitleLabel.setText("Host: "+_ip);
    }
  }//setEnabe
}//NodeDataManager