package coamonitor;

/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */
import coamonitor.Data.*;
import javax.swing.*;

public class ServerDataManager {

  int totCall = 0;
  int totCallSucc = 0;
  int totCallInsucc = 0;
  int totCallTime = 0;

  boolean enable = true;

  //OutputPanel
  ApplicationPanel appPane = null;

  public ServerDataManager(ApplicationPanel ap) {
    appPane = ap;
  }

  public void displaySrReqData(RequestData rd){
    totCall++;

    if(rd.result){
      totCallSucc++;
    }else{
      totCallInsucc++;
    }
    totCallTime = totCallTime+rd.time;

    if(enable){
      appPane.jSrCallInsuccTextField.setText((new Integer(totCallInsucc)).toString());
      appPane.jSrSuccessTextField.setText((new Integer(totCallSucc)).toString());
      appPane.jSrCallTextField.setText((new Integer(totCall)).toString());
      appPane.jSrCallTimeTextField.setText((new Integer(totCallTime)).toString());
      appPane.jSrLastOpTextArea.append(reqDataToString(rd));
    }
  }//displayClReqData

   public String reqDataToString(RequestData rd){
    String output = "";
    String result = "";
    if(rd.result){  result = "Success"; }
    else{ result = "Fail";  }

    output = "Object Name: "+rd.ObjectName+"\nOperation Name: "+rd.OperationName+"\nResult: "+result
    +"\nOperationTime: "+rd.time+"\n\n";
    return output;
  }//requestDataToString

  public void displayMessage(String in){
    if(enable){
      appPane.jMessageArea.append(in+"\n");
    }
  }//displayMessage

  public void setEnable(boolean en){
    enable = en;
  }
}