package coamonitor;

/**
 * Title:        Corba Object Activity Monitor
 * Description:  Monitor  dell'attivit svolta da oggetti CORBA residenti sui nodi di una rete LAN.
 * Copyright:    Copyright (c) 2001
 * Company:      DEIS
 * @author FMorroia
 * @version 1.0
 */

import com.inprise.vbroker.ObjLocation.*;
import javax.swing.*;
import javax.swing.tree.*;
import java.util.*;
import coamonitor.Interceptor.*;

public class TreeManager implements FinderListener {

  private int nodeNumber = 0;
  private InterceptorFinder finder = null;
  private JTree tree = null;
  private DefaultTreeModel model = null;
  private DefaultMutableTreeNode root = null;

  public TreeManager(org.omg.CORBA.ORB orb) {
    initTree( orb);
  }//TreeManager

  protected void initTree(org.omg.CORBA.ORB orb){
    root = new DefaultMutableTreeNode("Interceptor Node");
    model = new DefaultTreeModel(root);
    tree = new JTree(model);
    int mode = TreeSelectionModel.SINGLE_TREE_SELECTION;
    tree.getSelectionModel().setSelectionMode(mode);
    finder = new InterceptorFinder(orb,this);
    finder.find();
  }//initTree


  public JTree getTree(){
    return tree;
  }//getTree

  //Implementation of FinderListener Interface
  public void interceptorFound(Desc d){
    Desc currentDesc = d;

    String ip = currentDesc.iiop_locator.host;
    boolean res = false;
    Enumeration bf = root.breadthFirstEnumeration();
    bf.nextElement();
    if(!bf.hasMoreElements()){
      DefaultMutableTreeNode node = new DefaultMutableTreeNode(ip);
      nodeNumber++;
      model.insertNodeInto(node,root,root.getChildCount());
      nodeNumber++;
      this.addLeaf(node,currentDesc);
    }else{
      DefaultMutableTreeNode currentNode = ((DefaultMutableTreeNode)bf.nextElement());
      while((currentNode.getParent().equals(root))&(!res)& bf.hasMoreElements()){
        if(currentNode.getUserObject().equals(ip)){
          nodeNumber++;
          this.addLeaf(currentNode,currentDesc);
          res = true;
        }
        currentNode = ((DefaultMutableTreeNode)bf.nextElement());
      }

      if(!res){
        DefaultMutableTreeNode node = new DefaultMutableTreeNode(ip);
        nodeNumber++;
        model.insertNodeInto(node,root,root.getChildCount());
        nodeNumber++;
        this.addLeaf(node,currentDesc);
      }
    }
    System.out.println("Numero nodi aggiunti: "+nodeNumber);
    nodeNumber = 0;
   }//InterceptroFound

  public void addLeaf(DefaultMutableTreeNode node, Desc desc){
    DefaultMutableTreeNode newNode = new DefaultMutableTreeNode();
    newNode.setUserObject(desc);
    model.insertNodeInto(newNode,node,node.getChildCount());
    TreeNode[] nodes = model.getPathToRoot(newNode);
    TreePath path = new TreePath(nodes);
    tree.makeVisible(path);
  }//addNode

  public void removeNode(DefaultMutableTreeNode node){
    if(!node.getUserObject().getClass().toString().equals("class java.lang.String")){
    //if is leaf remove Binder
      com.inprise.vbroker.ObjLocation.Desc desc = (com.inprise.vbroker.ObjLocation.Desc)node.getUserObject();
      MonitorBinder binder = MonitorBinderHelper.narrow(desc.ref);

      binder.removeListener();
    }
  }//removeNode

  public void removeAllNode(){
    int i = 1;
    Enumeration bf = root.depthFirstEnumeration();
    DefaultMutableTreeNode currentNode = null;
    System.out.println("Numero colonne: "+tree.getRowCount());
    while(bf.hasMoreElements()){
      currentNode = (DefaultMutableTreeNode)bf.nextElement();
      if((!(currentNode.getUserObject().getClass().toString().equals("class java.lang.String")))){

        System.out.println("Passo di rimozione "+i++);
        this.removeNode(currentNode);
      }
    }

    System.out.println("Numero colonne: "+tree.getRowCount());
  }//removeAllNode

  public void deleteInterceptor(Desc d){

  }//deleteinterceptor
}